Subject: A Chinese Keyboard Question (rephrased)

From: "L.S.Ng" <[email-masked]>
Date: Tue, 18 May 1993 10:45:40 BST

A Chinese Keyboard Question
---------------------------

A keyboard layout for a Chinese script has been designed and in used for some
time. It was found to have the following frequency distribution:

Key            Relative Frequency
m              4669
i              3632
h              3470
o              3346
l              2476
n              2453
y              2207
k              2092
b              1913
p              1840
d              1803
r              1788
a              1662
s              1497
g              1488
q              1481
u              1381
t              1319
v              1304
j              1224
e              1112
f              1041
w              906
c              840
x              188
z              2

'a' to 'z' denote the usual position of a standard QWERTY keyboard.
The numbers associated with each key is the relative frequency.

Problem: It can be seen that the layout was not ergonomically
optimized:
i) The left-hand and right-hand workload were not balanced.
ii) The frequently-hit keys did not fall into the most comfortable
places.
iii) plus other constraints which you can think of

A solution is therefore wanted to remap or redesign the keyboard
layout so that it has a optimized ergonomic design.

To rephrase the problem more formally, let's define some notation:

  lower case letters {a,..,z} denote the Chinese Alphabets
  upper case letters {A,..,Z} denote the usual position on a QWERTY Keyboard.

In the old design (as above), {a,..,z} are mapped to {A,..Z} such that
a->A, b->B, ...., c->Z
(read: the Chinese alphabet 'a' maps to position 'A' on the QWERTY keyboard...)

The new design is required such that {a,..z} -> {A,...,Z} such that
i) the most frequently hit key should fall on the most strategic place
ii) the left-hand and right-hand workload should be balanced
iii) plus other possible considerations
e.g.
m->J, i->F,...., z->Y
(read: the Chinese alphabet 'm' now maps to postion 'J' on a QWERTY
keyboard...)

Please send your comment and answer to Liangsheng Wu <[email-masked]>

Thanks for your attention.

Sincerely
Liangsheng Wu
Southampton UK

(This question was taken from a analysis on Chinese typewriting. It
had been simplified by taking away some unrelated technical and linguistic
details so as to present you a purely mathematical/design problem. Please feel
free to post to any newsgroup/mailing-list/interest group and reply to
Liangsheng Wu <[email-masked]>. This question was originally put up
to The Chinese Computing Network List [email-masked])

(A more comprehensive report on the analysis will be posted to
CCNET-L soon.)

Note: The word 'alphabet' means the elements in a script which can be any
script or the elements in any kind of representation e.g. In Digital Signal
Processing, the 'alphabets' are a High voltage and a Low voltage; any piece of
digital information is composed of a stream of High and Low voltages.

---

From: "L.S.Ng" <[email-masked]>
Date: Tue, 18 May 93 18:57:15 BST

That analysis was based on Cangjie. I purposely left out the details to make
the question simpler. But I will post my report on the analysis to CCNET soon.

Since you said keyboard remapping depends on the frequency distribution: that's
exactly what I give you (you don't really need to care which input method it
is). It should be possible to work out a design. But I do not have much
knowledge on keyboard designing so I post it to ask for solution.

Cheers
liangsheng wu